diff --git a/test/integration/run_review_test.rb b/test/integration/run_review_test.rb
index 80ef0996..3d5ec8a2 100644
--- a/test/integration/run_review_test.rb
+++ b/test/integration/run_review_test.rb
@@ -106,6 +106,304 @@ class RunReviewTest < Minitest::Test
     MD
   end
 
+  def prepare_tmux_fallback_review(folder, unresolved_escalation: false)
+    worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml"))).fetch("path")
+    reviewer = File.join(folder, "reviews", "stub-reviewer-01.md")
+    FileUtils.mkdir_p(File.dirname(reviewer))
+    File.write(reviewer, "## High\n- [x] AUTO-FIX: apply the review fix\n")
+    if unresolved_escalation
+      File.write(File.join(folder, "reviews", "escalations-01.md"), <<~MD)
+        # Escalations for pass 01
+
+        ### Q1. Which behavior should be used?
+        Source: stub-reviewer-01.md
+        ### A1.
+      MD
+    end
+    settings = File.join(worktree, ".claude", "settings.json")
+    FileUtils.mkdir_p(File.dirname(settings))
+    File.write(settings, %({"project":true}\n))
+    run!("git", "-C", worktree, "add", ".")
+    run!("git", "-C", worktree, "commit", "-m", "test: add project settings", "--quiet")
+    Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
+    [ worktree, settings ]
+  end
+
+  def fallback_review_runner(folder:, worktree:, outcome:, exit_status: 0,
+                             pane_mode: :normal, malformed_evidence: false,
+                             missing_output: false, dirty_only: false,
+                             write_evidence: true, normal_signal: false,
+                             normal_signal_status: "success",
+                             unreadable_worktree: false)
+    test_run = method(:run!)
+    runner = Object.new
+    tails = case pane_mode
+    when :crash
+      [ "fatal error: Claude crashed" ]
+    when :idle_only
+      [ "Claude Code v2\n❯" ]
+    else
+      [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+    end
+    runner.instance_variable_set(:@tails, tails)
+    runner.instance_variable_set(:@exit_status, exit_status)
+    runner.instance_variable_set(:@pane_dead, false)
+    runner.define_singleton_method(:name) { "review-fallback-session" }
+    runner.define_singleton_method(:pane_pid) do
+      raise Hive::TmuxError, "session already killed" if @killed
+
+      12_345
+    end
+    runner.define_singleton_method(:start_detached) { |command:| @command = command }
+    runner.define_singleton_method(:capture_pane_tail) do |bytes:|
+      raise Hive::TmuxError, "pane unavailable" if %i[unreadable gone].include?(pane_mode)
+
+      @tails.shift || (pane_mode == :crash ? "fatal error: Claude crashed" : "Claude Code v2\n❯")
+    end
+    runner.define_singleton_method(:enable_remain_on_exit) { true }
+    runner.define_singleton_method(:send_prompt) do |text|
+      if text == "/quit"
+        @quit = true
+        @pane_dead = true
+        next
+      end
+      next if @authored
+
+      @authored = true
+      next unless write_evidence
+
+      evidence_path = File.join(folder, "reviews", "fix-result-01.json")
+      if malformed_evidence
+        File.write(evidence_path, "{")
+        next
+      end
+
+      commits = []
+      if outcome == :changed
+        File.write(File.join(worktree, "README.md"), "fixed by fallback\n")
+        test_run.call("git", "-C", worktree, "add", "README.md")
+        test_run.call("git", "-C", worktree, "commit", "-m", <<~MSG, "--quiet")
+          fix(review): apply fallback review fix
+
+          Hive-Task-Slug: #{File.basename(folder)}
+          Hive-Fix-Pass: 01
+          Hive-Fix-Findings: 1
+          Hive-Triage-Bias: courageous
+          Hive-Reviewer-Sources: stub-reviewer
+          Hive-Fix-Phase: fix
+        MSG
+        commits << `git -C #{worktree} rev-parse HEAD`.strip
+      elsif dirty_only
+        File.write(File.join(worktree, "dirty-only.txt"), "not committed\n")
+      end
+
+      File.write(evidence_path, JSON.pretty_generate(
+        "version" => 1,
+        "pass" => 1,
+        "task_slug" => File.basename(folder),
+        "outcome" => outcome == :changed ? "changed" : "no_changes_needed",
+        "rationale" => outcome == :changed ? "Applied the accepted fix." : "No code change was needed.",
+        "findings" => [
+          { "id" => "stub-reviewer-01.md:2", "disposition" => outcome == :changed ? "addressed" : "no change needed" }
+        ],
+        "commits" => commits,
+        "unresolved_escalation" => false,
+        "missing_output" => missing_output
+      ))
+      if normal_signal
+        File.write(File.join(folder, "result.json"), JSON.generate("status" => normal_signal_status))
+        File.write(File.join(folder, ".done"), "")
+      end
+      if unreadable_worktree
+        @git_dir = File.join(worktree, ".git")
+        @hidden_git_dir = File.join(worktree, ".git-unreadable")
+        FileUtils.mv(@git_dir, @hidden_git_dir)
+      end
+    end
+    runner.define_singleton_method(:pane_dead?) { @pane_dead }
+    runner.define_singleton_method(:pane_dead_status) { @exit_status }
+    runner.define_singleton_method(:session_exists?) { pane_mode != :gone && !@killed }
+    runner.define_singleton_method(:kill_session) do
+      FileUtils.mv(@hidden_git_dir, @git_dir) if @hidden_git_dir && File.exist?(@hidden_git_dir)
+      @killed = true
+    end
+    runner
+  end
+
+  def with_fake_tmux_review_runner(runner)
+    with_replaced_singleton_method(Hive::ClaudeLauncher, :build_runner, ->(**) { runner }) do
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :preflight!, ->(*) { }) do
+        with_replaced_singleton_method(Hive::ClaudeLauncher, :wrapper_command, ->(**) { [ "claude" ] }) do
+          with_replaced_singleton_method(Hive::ClaudeLauncher, :wait_until_session_exists!, ->(*) { }) do
+            with_replaced_singleton_method(Hive::ClaudeLauncher, :record_claude_pid, ->(*) { }) do
+              with_replaced_singleton_method(Hive::ClaudeLauncher, :prepare_claude_session!, ->(*) { }) do
+                with_replaced_singleton_method(Hive::ClaudeLauncher, :sweep_orphan_processes, ->(*) { }) do
+                  yield
+                end
+              end
+            end
+          end
+        end
+      end
+    end
+  end
+
+  def assert_fallback_cleanup(folder, settings, runner)
+    refute File.exist?(File.join(folder, ".done"))
+    refute File.exist?(File.join(folder, "result.json"))
+    assert_equal %({"project":true}\n), File.read(settings)
+    assert runner.instance_variable_get(:@killed), "managed tmux session must be cleaned up"
+  end
+
+  def test_tmux_fix_fallback_accepts_changed_evidence_and_audits_before_completion
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir, cfg_overrides: {
+          "claude" => { "mode" => "tmux" },
+          "stages" => { "ensure_clean_on_exit" => false }
+        })
+        worktree, settings = prepare_tmux_fallback_review(folder)
+        runner = fallback_review_runner(folder: folder, worktree: worktree, outcome: :changed)
+
+        _out, _err, status = with_fake_tmux_review_runner(runner) do
+          with_captured_exit { Hive::Commands::Run.new(folder).call }
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal 0, status, "marker=#{marker.name} attrs=#{marker.attrs.inspect}"
+        assert_equal :review_complete, marker.name
+        events = File.readlines(File.join(folder, "events.jsonl")).map { |line| JSON.parse(line) }
+        fallback_events = events.select { |event| event["event_type"] == "claude_completion_fallback" }
+        assert_equal 1, fallback_events.length
+        message = fallback_events.first.fetch("message")
+        assert_includes message, "level=WARN"
+        assert_includes message, "commit_range="
+        refute_includes message, Hive::Events::MESSAGE_TRUNCATION_SUFFIX
+        assert_equal "fixed by fallback\n", File.read(File.join(worktree, "README.md"))
+        assert_fallback_cleanup(folder, settings, runner)
+      end
+    end
+  end
+
+  def test_tmux_fix_fallback_accepts_explicit_no_change_evidence
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir, cfg_overrides: {
+          "claude" => { "mode" => "tmux" },
+          "stages" => { "ensure_clean_on_exit" => false }
+        })
+        worktree, settings = prepare_tmux_fallback_review(folder)
+        start_head = `git -C #{worktree} rev-parse HEAD`.strip
+        runner = fallback_review_runner(folder: folder, worktree: worktree, outcome: :no_changes)
+
+        _out, _err, status = with_fake_tmux_review_runner(runner) do
+          with_captured_exit { Hive::Commands::Run.new(folder).call }
+        end
+
+        assert_equal 0, status
+        assert_equal start_head, `git -C #{worktree} rev-parse HEAD`.strip
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_complete, marker.name
+        event = File.readlines(File.join(folder, "events.jsonl"))
+                    .map { |line| JSON.parse(line) }
+                    .find { |row| row["event_type"] == "claude_completion_fallback" }
+        refute_nil event
+        assert_includes event.fetch("message"), "no_change_rationale=No_code_change_was_needed."
+        assert_fallback_cleanup(folder, settings, runner)
+      end
+    end
+  end
+
+  def test_tmux_fix_normal_stop_completion_does_not_emit_fallback_event
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir, cfg_overrides: {
+          "claude" => { "mode" => "tmux" },
+          "stages" => { "ensure_clean_on_exit" => false }
+        })
+        worktree, settings = prepare_tmux_fallback_review(folder)
+        runner = fallback_review_runner(
+          folder: folder,
+          worktree: worktree,
+          outcome: :no_changes,
+          normal_signal: true
+        )
+
+        _out, _err, status = with_fake_tmux_review_runner(runner) do
+          with_captured_exit { Hive::Commands::Run.new(folder).call }
+        end
+
+        assert_equal 0, status
+        assert_equal :review_complete, Hive::Markers.current(File.join(folder, "task.md")).name
+        events = File.readlines(File.join(folder, "events.jsonl")).map { |line| JSON.parse(line) }
+        refute events.any? { |event| event["event_type"] == "claude_completion_fallback" }
+        assert_fallback_cleanup(folder, settings, runner)
+      end
+    end
+  end
+
+  def test_tmux_fix_fallback_strictly_rejects_crash_exit_and_artifact_failures
+    scenarios = {
+      crash: { pane_mode: :crash },
+      nonzero_exit: { exit_status: 7 },
+      unknown_exit: { exit_status: "unknown" },
+      prework_idle: { pane_mode: :idle_only, review_timeout: 0 },
+      unreadable_pane: { pane_mode: :unreadable },
+      gone_pane: { pane_mode: :gone },
+      stop_result_failure: { normal_signal: true, normal_signal_status: "cancelled" },
+      missing_evidence: { write_evidence: false },
+      malformed_evidence: { malformed_evidence: true },
+      unresolved_escalation: { unresolved_escalation: true },
+      missing_output_confirmation: { missing_output: true },
+      dirty_only: { dirty_only: true },
+      unreadable_worktree: { unreadable_worktree: true }
+    }
+
+    scenarios.each do |name, options|
+      with_tmp_global_config do
+        with_tmp_git_repo do |dir|
+          folder = setup_review_task(dir, cfg_overrides: {
+            "claude" => { "mode" => "tmux" },
+            "timeout_sec" => { "review_fix" => options.delete(:review_timeout) || 2700 },
+            "stages" => { "ensure_clean_on_exit" => false }
+          })
+          worktree, settings = prepare_tmux_fallback_review(
+            folder,
+            unresolved_escalation: options.delete(:unresolved_escalation) == true
+          )
+          runner = fallback_review_runner(
+            folder: folder,
+            worktree: worktree,
+            outcome: :no_changes,
+            **options
+          )
+
+          _out, _err, status = with_fake_tmux_review_runner(runner) do
+            with_captured_exit { Hive::Commands::Run.new(folder).call }
+          end
+
+          assert_equal Hive::ExitCodes::TASK_IN_ERROR, status, name.to_s
+          marker = Hive::Markers.current(File.join(folder, "task.md"))
+          assert_equal :review_error, marker.name, name.to_s
+          assert_equal "fix", marker.attrs["phase"], name.to_s
+          assert_equal "fix_failed", marker.attrs["reason"], name.to_s
+          if name == :crash
+            assert_includes marker.attrs.fetch("message"), "reported a failure", name.to_s
+          elsif %i[unreadable_pane gone_pane].include?(name)
+            assert_match(/tmux_(pane_unreadable|session_terminated)/, marker.attrs.fetch("message"), name.to_s)
+          elsif name == :stop_result_failure
+            assert_match(/reported :cancelled/, marker.attrs.fetch("message"), name.to_s)
+          else
+            assert_equal "claude stop hook did not signal completion", marker.attrs["message"], name.to_s
+          end
+          events = File.readlines(File.join(folder, "events.jsonl")).map { |line| JSON.parse(line) }
+          refute events.any? { |event| event["event_type"] == "claude_completion_fallback" }, name.to_s
+          assert_fallback_cleanup(folder, settings, runner)
+        end
+      end
+    end
+  end
+
   def suppression_reviewer_cfg
     {
       "review" => {
@@ -1015,6 +1313,37 @@ class RunReviewTest < Minitest::Test
     end
   end
 
+  def test_review_fix_agent_rewriting_reviewer_output_yields_fix_tampered
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        reviews = File.join(folder, "reviews")
+        FileUtils.mkdir_p(reviews)
+        reviewer = File.join(reviews, "local-reviewer-01.md")
+        File.write(reviewer, "## High\n- [x] apply a fix\n")
+        Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
+        File.write(@driver_bin, <<~SH)
+          #!/usr/bin/env bash
+          if [[ "${1:-}" == "--version" ]]; then
+            echo "2.1.118 (Claude Code)"
+            exit 0
+          fi
+          printf '## Forged\n- [x] different finding\n' > "#{reviewer}"
+          exit 0
+        SH
+        File.chmod(0o755, @driver_bin)
+
+        _out, _err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+
+        assert_equal Hive::ExitCodes::TASK_IN_ERROR, status
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix_tampered", marker.attrs["reason"]
+        assert_includes marker.attrs.fetch("files"), "reviews/local-reviewer-01.md"
+      end
+    end
+  end
+
   # --- agents.* config override plumbed end-to-end --------------------
 
   def test_agents_config_override_flows_through_to_reviewer_spawn
@@ -1310,7 +1639,7 @@ class RunReviewTest < Minitest::Test
               status: :ok, escalations_path: esc, error_message: nil, tampered_files: [], limit_text: nil
             )
           }) do
-            with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+            with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_kwargs|
               flunk "ad-hoc review should not run fix by default with accepted=#{accepted.inspect}"
             }) do
               capture_io { Hive::Commands::Run.new(folder).call }
@@ -1341,7 +1670,7 @@ class RunReviewTest < Minitest::Test
         Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
 
         accepted_seen = nil
-        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_kwargs|
           accepted_seen = accepted
           { status: :ok }
         }) do
@@ -2325,7 +2654,7 @@ class RunReviewTest < Minitest::Test
         Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
 
         accepted_seen = nil
-        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_kwargs|
           accepted_seen = accepted
           { status: :error, error_message: "fix failed" }
         }) do
@@ -2352,7 +2681,7 @@ class RunReviewTest < Minitest::Test
         Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
 
         accepted_seen = nil
-        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:, **_kwargs|
           accepted_seen = accepted
           {
             status: :error,
diff --git a/test/unit/claude_completion_fallback_test.rb b/test/unit/claude_completion_fallback_test.rb
new file mode 100644
index 00000000..32b48c03
--- /dev/null
+++ b/test/unit/claude_completion_fallback_test.rb
@@ -0,0 +1,61 @@
+require "test_helper"
+require "hive/claude_completion_fallback"
+
+class ClaudeCompletionFallbackTest < Minitest::Test
+  REQUIRED_FACTS = %i[
+    sentinel_missing
+    work_started
+    returned_to_idle
+    stable_idle
+    session_readable
+    no_failure_output
+    no_failure_result
+    probe_accepted
+  ].freeze
+
+  def evidence(**overrides)
+    Hive::ClaudeCompletionFallback::Evidence.new(
+      phase: "review_fix",
+      sentinel_path: "/tmp/.done",
+      missing_signal_reason: "stop_hook_sentinel_missing",
+      session_name: "hive-review",
+      pane_pid: 123,
+      sentinel_missing: true,
+      work_started: true,
+      returned_to_idle: true,
+      stable_idle: true,
+      session_readable: true,
+      no_failure_output: true,
+      no_failure_result: true,
+      probe_accepted: true,
+      exit_status: 0,
+      probe: { artifacts_checked: [ "reviews/fix-result-01.json" ] }
+    ).with(**overrides)
+  end
+
+  def test_accepts_only_the_complete_conjunction
+    decision = Hive::ClaudeCompletionFallback.evaluate(evidence)
+
+    assert decision.accepted?
+    assert_empty decision.rejections
+    assert_equal "review_fix", decision.to_h.fetch(:phase)
+  end
+
+  def test_rejects_each_required_boolean_when_false
+    REQUIRED_FACTS.each do |fact|
+      decision = Hive::ClaudeCompletionFallback.evaluate(evidence(fact => false))
+
+      refute decision.accepted?, "#{fact} must be required"
+      assert_includes decision.rejections, fact
+    end
+  end
+
+  def test_rejects_nonzero_or_unknown_exit_status
+    [ 1, nil, "0" ].each do |status|
+      decision = Hive::ClaudeCompletionFallback.evaluate(evidence(exit_status: status))
+
+      refute decision.accepted?
+      assert_includes decision.rejections, :exit_status_zero
+    end
+  end
+end
